# -*- coding: utf-8 -*-

from http import HTTPStatus

# HTTP Status codes
# - https://en.wikipedia.org/wiki/List_of_HTTP_status_codes
# - https://developer.mozilla.org/ko/docs/Web/HTTP/Status

# ----------------------
# Informational response
# ----------------------

STATUS_CONTINUE = HTTPStatus.CONTINUE
STATUS_SWITCHING_PROTOCOLS = HTTPStatus.SWITCHING_PROTOCOLS
STATUS_PROCESSING = HTTPStatus.PROCESSING

# ----------
# Successful
# ----------

STATUS_OK = HTTPStatus.OK
STATUS_CREATED = HTTPStatus.CREATED
STATUS_ACCEPTED = HTTPStatus.ACCEPTED
STATUS_NON_AUTHORITATIVE_INFORMATION = HTTPStatus.NON_AUTHORITATIVE_INFORMATION
STATUS_NO_CONTENT = HTTPStatus.NO_CONTENT
STATUS_RESET_CONTENT = HTTPStatus.RESET_CONTENT
STATUS_PARTIAL_CONTENT = HTTPStatus.PARTIAL_CONTENT
STATUS_MULTI_STATUS = HTTPStatus.MULTI_STATUS
STATUS_ALREADY_REPORTED = HTTPStatus.ALREADY_REPORTED
STATUS_IM_USED = HTTPStatus.IM_USED

# -----------
# Redirection
# -----------

STATUS_MULTIPLE_CHOICES = HTTPStatus.MULTIPLE_CHOICES
STATUS_MOVED_PERMANENTLY = HTTPStatus.MOVED_PERMANENTLY
STATUS_FOUND = HTTPStatus.FOUND
STATUS_SEE_OTHER = HTTPStatus.SEE_OTHER
STATUS_NOT_MODIFIED = HTTPStatus.NOT_MODIFIED
STATUS_USE_PROXY = HTTPStatus.USE_PROXY
STATUS_TEMPORARY_REDIRECT = HTTPStatus.TEMPORARY_REDIRECT
STATUS_PERMANENT_REDIRECT = HTTPStatus.PERMANENT_REDIRECT

# -------------
# Client errors
# -------------

STATUS_BAD_REQUEST = HTTPStatus.BAD_REQUEST
STATUS_UNAUTHORIZED = HTTPStatus.UNAUTHORIZED
STATUS_PAYMENT_REQUIRED = HTTPStatus.PAYMENT_REQUIRED
STATUS_FORBIDDEN = HTTPStatus.FORBIDDEN
STATUS_NOT_FOUND = HTTPStatus.NOT_FOUND
STATUS_METHOD_NOT_ALLOWED = HTTPStatus.METHOD_NOT_ALLOWED
STATUS_NOT_ACCEPTABLE = HTTPStatus.NOT_ACCEPTABLE
STATUS_PROXY_AUTHENTICATION_REQUIRED = HTTPStatus.PROXY_AUTHENTICATION_REQUIRED
STATUS_REQUEST_TIMEOUT = HTTPStatus.REQUEST_TIMEOUT
STATUS_CONFLICT = HTTPStatus.CONFLICT
STATUS_GONE = HTTPStatus.GONE
STATUS_LENGTH_REQUIRED = HTTPStatus.LENGTH_REQUIRED
STATUS_PRECONDITION_FAILED = HTTPStatus.PRECONDITION_FAILED
STATUS_REQUEST_ENTITY_TOO_LARGE = HTTPStatus.REQUEST_ENTITY_TOO_LARGE
STATUS_REQUEST_URI_TOO_LONG = HTTPStatus.REQUEST_URI_TOO_LONG
STATUS_UNSUPPORTED_MEDIA_TYPE = HTTPStatus.UNSUPPORTED_MEDIA_TYPE
STATUS_REQUESTED_RANGE_NOT_SATISFIABLE = HTTPStatus.REQUESTED_RANGE_NOT_SATISFIABLE
STATUS_EXPECTATION_FAILED = HTTPStatus.EXPECTATION_FAILED
STATUS_MISDIRECTED_REQUEST = HTTPStatus.MISDIRECTED_REQUEST
STATUS_UNPROCESSABLE_ENTITY = HTTPStatus.UNPROCESSABLE_ENTITY
STATUS_LOCKED = HTTPStatus.LOCKED
STATUS_FAILED_DEPENDENCY = HTTPStatus.FAILED_DEPENDENCY
STATUS_UPGRADE_REQUIRED = HTTPStatus.UPGRADE_REQUIRED
STATUS_PRECONDITION_REQUIRED = HTTPStatus.PRECONDITION_REQUIRED
STATUS_TOO_MANY_REQUESTS = HTTPStatus.TOO_MANY_REQUESTS
STATUS_REQUEST_HEADER_FIELDS_TOO_LARGE = HTTPStatus.REQUEST_HEADER_FIELDS_TOO_LARGE
STATUS_UNAVAILABLE_FOR_LEGAL_REASONS = HTTPStatus.UNAVAILABLE_FOR_LEGAL_REASONS

# -------------
# Server errors
# -------------

STATUS_INTERNAL_SERVER_ERROR = HTTPStatus.INTERNAL_SERVER_ERROR
STATUS_NOT_IMPLEMENTED = HTTPStatus.NOT_IMPLEMENTED
STATUS_BAD_GATEWAY = HTTPStatus.BAD_GATEWAY
STATUS_SERVICE_UNAVAILABLE = HTTPStatus.SERVICE_UNAVAILABLE
STATUS_GATEWAY_TIMEOUT = HTTPStatus.GATEWAY_TIMEOUT
STATUS_HTTP_VERSION_NOT_SUPPORTED = HTTPStatus.HTTP_VERSION_NOT_SUPPORTED
STATUS_VARIANT_ALSO_NEGOTIATES = HTTPStatus.VARIANT_ALSO_NEGOTIATES
STATUS_INSUFFICIENT_STORAGE = HTTPStatus.INSUFFICIENT_STORAGE
STATUS_LOOP_DETECTED = HTTPStatus.LOOP_DETECTED
STATUS_NOT_EXTENDED = HTTPStatus.NOT_EXTENDED
STATUS_NETWORK_AUTHENTICATION_REQUIRED = HTTPStatus.NETWORK_AUTHENTICATION_REQUIRED
